Index: trunk/MagicSoft/Simulation/Detector/Camera/camera.cxx
===================================================================
--- trunk/MagicSoft/Simulation/Detector/Camera/camera.cxx	(revision 1260)
+++ trunk/MagicSoft/Simulation/Detector/Camera/camera.cxx	(revision 1311)
@@ -21,7 +21,7 @@
 //
 // $RCSfile: camera.cxx,v $
-// $Revision: 1.38 $
+// $Revision: 1.39 $
 // $Author: blanch $ 
-// $Date: 2002-03-18 18:44:29 $
+// $Date: 2002-04-27 10:48:39 $
 //
 ////////////////////////////////////////////////////////////////////////
@@ -170,7 +170,4 @@
 static float ct_PixelWidth_corner_2_corner; 
 
-//@: ct_PixelWidth_corner_2_corner / 2
-static float ct_PixelWidth_corner_2_corner_half; 
-
 //@: Number of mirrors
 static int ct_NMirrors = 0;   
@@ -184,10 +181,4 @@
 //@: Number of pixels
 static int ct_NGapPixels;        
-
-//@: ct_Apot = ct_PixelWidth / 2
-static float ct_Apot;          
-
-//@: ct_2Apot = 2 * ct_Apot = ct_PixelWidth 
-static float ct_2Apot;         
 
 //@: name of the CT definition file to use
@@ -421,5 +412,5 @@
   float thetaCT, phiCT;       //@< parameters of a given shower
   float thetashw, phishw;     //@< parameters of a given shower
-  float coreD, coreX, coreY;         //@< core position
+  float coreX, coreY;         //@< core position
   float impactD;              //@< impact parameter
   float l1, m1, n1;           //@< auxiliary variables
@@ -464,6 +455,4 @@
 
   float qTailCut;             //@< Tail Cut value
-  int nIslandsCut;            //@< Islands Cut value
-  int countIslands=FALSE;           //@< Will we count the islands?
   int anaPixels;
     
@@ -478,5 +467,4 @@
   int isorttopo[3];           //@< sorting the topologies
   int icontrigger;            //@< number of trigger conditions to be analised
-  UShort_t numPix;            //@< number of sets of fadc written counts
 
   float fpixelthres[CAMERA_PIXELS];         //@< Threshold values
@@ -484,5 +472,4 @@
   TArrayC *fadcValues;  //@< the analog Fadc signal for pixels
 
-  float plateScale_cm2deg;    //@< plate scale (deg/cm)
   float degTriggerZone;       //@< trigger area in the camera (radius, in deg.)
 
@@ -631,5 +618,4 @@
   addElecNoise = add_elec_noise(&FADC_noise, &Trigger_noise);
   simulateNSB = get_nsb( &meanNSB, &nphe2NSB );  
-  countIslands = get_islands_cut( &nIslandsCut );
 
   // get selections on the parameters
@@ -765,5 +751,5 @@
   read_pixels(&cam);
 
-  Int_t Lev0, Lev1, Lev2 ; 
+  Int_t Lev0, Lev1; 
   
   fadcValues =  new TArrayC(FADC_SLICES);
@@ -1090,7 +1076,5 @@
   }
   
-  // set plate scale (deg/cm) and trigger area (deg)
-
-  plateScale_cm2deg = ( ct_Type == 0 ) ? (0.244/2.1) : 0.030952381;
+  // set trigger area (deg)
 
   if ( ! get_trigger_radius( &degTriggerZone ) )
@@ -1234,8 +1218,4 @@
 	fread( (char*)&mcevth, mcevth.mysize(), 1, inputfile );
 
-	// calculate core distance and impact parameter
-	
-	coreD = mcevth.get_core(&coreX, &coreY);
-		
 	// calculate impact parameter (shortest distance betwee the original
 	// trajectory of the primary (assumed shower-axis) and the
@@ -1286,5 +1266,7 @@
 	  // therefore, we calculate the impact parameter as the distance 
 	  // between the CT axis and the core position
-	  
+
+	  mcevth.get_core(&coreX, &coreY);
+		
 	  impactD = dist_r_P( 0., 0., 0., l1, m1, n1, coreX, coreY, 0. );
 	  
@@ -1456,5 +1438,5 @@
 	    
 	    //  Set trigger flags to zero
-	    Lev1=Lev2=0;
+	    Lev1=0;
 
 	    //  loop over multiplicity of trigger configuration
@@ -1468,5 +1450,5 @@
 		//  loop over topologies
 		for(itopocount=Trigger_loop_ltop;itopocount<=Trigger_loop_utop;itopocount++){
-		  Lev1=Lev2=0;
+		  Lev1=0;
 		
 		  if(itopocount==0 && imulticount>7) continue;
@@ -1500,5 +1482,5 @@
 		    Lev0=0;
 		  }
-		  numPix=0;
+
 		  for (Int_t ii=0;ii<Lev1;ii++){
 		      if (Write_McTrig){
@@ -1605,5 +1587,5 @@
 	  Lev0 = (Short_t) Trigger.ZeroLevel() ; 
 	  
-	  Lev1 = Lev2 = 0 ; 
+	  Lev1 = 0 ; 
 	  
 	  //
@@ -1623,5 +1605,4 @@
 	  }
 
-	  numPix=0;
 	  for(Int_t ii=0;ii<Lev1;ii++){
 	    //  Loop over different level one triggers
@@ -2219,8 +2200,4 @@
 
       ct_PixelWidth_corner_2_corner = ct_PixelWidth / cos(RAD(30.0));
-      ct_PixelWidth_corner_2_corner_half =
-        ct_PixelWidth_corner_2_corner * 0.50;
-      ct_Apot = ct_PixelWidth / 2;
-      ct_2Apot = ct_Apot * 2.0;
 
       log( "read_ct_file", "Pixel width: %f cm\n", ct_PixelWidth );
@@ -2516,6 +2493,6 @@
   double dxfirst_pix;
   double dyfirst_pix;
-  double ddxseg1, ddxseg2, ddxseg3, ddxseg4, ddxseg5, ddxseg6;
-  double ddyseg1, ddyseg2, ddyseg3, ddyseg4, ddyseg5, ddyseg6;
+  double ddxseg1, ddxseg2, ddxseg3, ddxseg4, ddxseg5;
+  double ddyseg1, ddyseg2, ddyseg3, ddyseg4, ddyseg5;
   
 
@@ -2597,6 +2574,4 @@
     ddxseg5 = -ddxseg2;
     ddyseg5 = 0.;
-    ddxseg6 = -ddxseg1;
-    ddyseg6 = ddyseg1;
     
     /* to find the position of pixel ipixno take the position of the first pixel in the ring and move */
@@ -3378,4 +3353,7 @@
 //
 // $Log: not supported by cvs2svn $
+// Revision 1.38  2002/03/18 18:44:29  blanch
+// Small modificatin to set the electronic Noise in the MMcTrigHeader class.
+//
 // Revision 1.37  2002/03/18 16:42:20  blanch
 // The data member fProductionSite of the MMcRunHeader has been set to 0,
@@ -3491,4 +3469,7 @@
 //
 // $Log: not supported by cvs2svn $
+// Revision 1.38  2002/03/18 18:44:29  blanch
+// Small modificatin to set the electronic Noise in the MMcTrigHeader class.
+//
 // Revision 1.37  2002/03/18 16:42:20  blanch
 // The data member fProductionSite of the MMcRunHeader has been set to 0,